define("io.ox/office/spreadsheet/model/formula/impl/textfuncs",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";var d=b.ErrorCodes;return{ASC:{category:"text",hidden:!0,minParams:1,maxParams:1,type:"val"},BAHTTEXT:{category:"text",minParams:1,maxParams:1,type:"val"},CHAR:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:int",resolve:function(a){if(a<1||a>255)throw d.VALUE;return String.fromCharCode(a)}},CLEAN:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.replace(/[\x00-\x1f\x81\x8d\x8f\x90\x9d]/g,"")}},CODE:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return 0===a.length?d.VALUE:a.charCodeAt(0)}},CONCATENATE:{category:"text",minParams:1,type:"val",signature:"val:str",resolve:function(){return _.reduce(arguments,c.add,"")}},DBCS:{category:"text",supported:"ooxml",hidden:!0,minParams:1,maxParams:1,type:"val"},DOLLAR:{category:"text",minParams:1,maxParams:2,type:"val"},EXACT:{category:"text",minParams:2,maxParams:2,type:"val",signature:"val:str val:str",resolve:function(a,b){return a===b}},FIND:{category:"text",altNamesHidden:{ooxml:"FINDB"},minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:function(a,b,c){if(_.isUndefined(c)&&(c=1),this.checkStringIndex(c),c-=1,c>b.length-a.length)throw d.VALUE;if(c=b.indexOf(a,c),c<0)throw d.VALUE;return c+1}},FIXED:{category:"text",minParams:1,maxParams:3,type:"val"},JIS:{category:"text",supported:"odf",hidden:!0,minParams:1,maxParams:1,type:"val"},LEFT:{category:"text",altNamesHidden:"LEFTB",minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(a,b){return _.isUndefined(b)&&(b=1),this.checkStringLength(b),0===b?a:a.substr(0,b)}},LEN:{category:"text",altNamesHidden:"LENB",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:_.property("length")},LOWER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.toLowerCase()}},MID:{category:"text",altNamesHidden:"MIDB",minParams:3,maxParams:3,type:"val",signature:"val:str val:int val:int",resolve:function(a,b,c){return this.checkStringIndex(b),this.checkStringLength(c),a.substr(b-1,c)}},NUMBERVALUE:{category:"text",minParams:1,maxParams:3,type:"val"},PHONETIC:{category:"text",supported:"ooxml",hidden:!0,minParams:1,maxParams:1,type:"val",signature:"ref:single"},PROPER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(b){return b.replace(/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02B8\u02BB-\u02C1\u02D0-\u02D1\u02E0-\u02E4\u02EE\u0370-\u0373\u0376-\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0523]+/g,a.capitalize)}},REPLACE:{category:"text",altNamesHidden:{ooxml:"REPLACEB"},minParams:4,maxParams:4,type:"val",signature:"val:str val:int val:int val:str",resolve:function(b,c,d,e){return this.checkStringIndex(c),this.checkStringLength(d),c-=1,a.replaceSubString(b,c,c+d,e)}},REPT:{category:"text",minParams:2,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(b,c){return this.checkStringLength(b.length*c),0===b.length?"":a.repeatString(b,c)}},RIGHT:{category:"text",altNamesHidden:"RIGHTB",minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(a,b){return _.isUndefined(b)&&(b=1),this.checkStringLength(b),0===b?a:a.substr(-b)}},ROT13:{category:"text",supported:"odf",minParams:1,maxParams:1,type:"val"},SEARCH:{category:"text",altNamesHidden:{ooxml:"SEARCHB"},minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:function(a,b,c){if(_.isUndefined(c)&&(c=1),this.checkStringIndex(c),c-=1,/^\**$/.test(a)){if(b.length<=c)throw d.VALUE;return c+1}b=b.substr(c);var e=this.convertPatternToRegExp(a),f=e.exec(b);if(!_.isArray(f))throw d.VALUE;return f.index+c+1}},SUBSTITUTE:{category:"text",minParams:3,maxParams:4,type:"val",signature:"val:str val:str val:str val:int",resolve:function(a,b,c,e){if(_.isNumber(e)&&e<=0)throw d.VALUE;if(0===b.length)return a;var f=new RegExp(_.escapeRegExp(b),"g");if(_.isUndefined(e))return a.replace(f,c);var g=a.split(f);return e<g.length?(g[e-1]+=c+g[e],g.splice(e,1),g.join(b)):a}},T:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val",resolve:function(a){return _.isString(a)?a:""}},TEXT:{category:"text",minParams:2,maxParams:2,type:"val"},TRIM:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.replace(/^ +| +$/,"").replace(/  +/g," ")}},UNICHAR:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:int",resolve:function(a){if(a<1||a>65535)throw d.VALUE;var b=String.fromCharCode(a);if(/[\ud800-\udfff\ufdd0-\ufdef\ufffe\uffff]/.test(b))throw d.NA;return b}},UNICODE:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return 0===a.length?d.VALUE:a.charCodeAt(0)}},UPPER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.toUpperCase()}},USDOLLAR:{category:"text",supported:"ooxml",hidden:!0,minParams:1,maxParams:2,type:"val"},VALUE:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return this.convertToNumber(a)}}}});